/* 	==========================================================================
   	Mixins
   	Defines all Sass functions.
   	========================================================================== */

   	/**
 	* 	TABLE OF CONTENTS
 	*
 	* 	1. GENERIC DEBUG MESSAGE E.G. FOR MEDIA QUERIES
 	* 	2. FONT SIZE & LINE HEIGHT
 	* 	3. BREAKPONTS
 	* 	4. BUTTONS
 	*	5. ITEMS
 	*	6. INLINE BLOCK
 	*
 	*/

   	/* 	1. GENERIC DEBUG MESSAGE E.G. FOR MEDIA QUERIES
   	========================================================================== */

   		@mixin debugmessage($message, $color: rgba(255,255,0, 0.9))
		{
			// margin-top: $body-line-height);

			&::before
			{
				content:$message;

				display: block;
				position: fixed;
				top:0;
				right:0;
				@include rem(height, $body-line-height);
				left:0;
				z-index:999;

				background:#{$color};
				opacity: 0.4;
				font-weight:bold;
				text-align:center;
			}
		}


   	/* 	2. FONT SIZE & LINE HEIGHT
   	========================================================================== */

   		@mixin setType($font-size, $line-height, $font-weight)
		{
			font-size: $font-size;
			line-height: $line-height;
			font-weight: $font-weight;
		}

		@mixin font-smoothing($font-smoothing)
		{
  			-webkit-font-smoothing: $font-smoothing;
  			        font-smoothing: $font-smoothing;
		}


	/* 	3. BREAKPOINT
   	========================================================================== */

		@mixin breakpoint($class) {
		  	@if $class == small {
		  	  	@media only screen and (min-width: 480px) { @content; }
		  	}

		  	@else if $class == medium {
		  	  	@media only screen and (min-width: 568px) { @content; }
		  	}

		  	@else if $class == large {
		  	  	@media only screen and (min-width: 800px) { @content; }
		  	}

		  	@else if $class == huge {
		  	  	@media only screen and (min-width: 992px) { @content; }
		  	}

		  	@else if $class == giant {
		  	  	@media only screen and (min-width: 1200px) { @content; }
		  	}

		  	@else if $class == monstrous {
		  	  	@media only screen and (min-width: 1420px) { @content; }
		  	}

		  	@else if $class == trex {
		  	  	@media only screen and (min-width: 1600px) { @content; }
		  	}

		  	@else {
		  	  	@warn "Breakpoint mixin supports: small, medium, large, huge, giant, monstrous and trex";
		  	}
		}


	/* 	4. BUTTON
   	========================================================================== */

		@mixin button-style($bg-color, $border-color, $hover-bg-color, $hover-border-color, $active-bg-color, $active-border-color, $color, $hover-color, $box-shadow) {
		  	border-color: $border-color;
		  	background-color: $bg-color;
		  	color: $color;
		  	box-shadow: $box-shadow;

		  	&:hover
		  	{
		    	color: $hover-color;
		    	text-decoration: none;
		    	border-color: $hover-border-color;
		    	background-color: $hover-bg-color;
		  	}

		  	// for devices that don't support :hover completely
		  	@media (hover:none), (hover:on-demand) {
		  		&:hover
		  		{
		    		color: $color;
		    		text-decoration: none;
		    		border-color: $border-color;
		    		background-color: $bg-color;
		  		}
		  	}
		  	
		  	&.active,
		  	&.activated {
		    	border-color: $active-border-color;
		    	background-color: $active-bg-color;
		  	}
		}


	/* 	5. ITEM
   	========================================================================== */

		@mixin item-style($bg-color, $border-color, $color, $hover-bg-color) {
  			border-color: $border-color;
  			background-color: $bg-color;
  			color: $color;

  			&:hover
  			{
  				background-color: $hover-bg-color;
  			}
		}


	/* 	6. INLINE BLOCK
	//	http://compass-style.org/reference/compass/css3/inline_block/
   	========================================================================== */

   		$inline-block-alignment: middle;
   		$graceful-usage-threshold: 0.1;
   		$inline-block-support-threshold: $graceful-usage-threshold;

		@mixin inline-block($alignment: $inline-block-alignment, $ie-alignment: auto) {
		  // legacy support for VERY old firefox
		  // @if support-legacy-browser("firefox", "2", $threshold: $inline-block-support-threshold) {
		  //   display: -moz-inline-stack;
		  // }
		  // standard
		  display: inline-block;
		  @if $alignment and $alignment != none {
		    vertical-align: $alignment;
		  }
		  // legacy IE support
		  //@if support-legacy-browser("ie", "7", $threshold: $inline-block-support-threshold) {
		  //  @if $ie-alignment and $ie-alignment != none {
		  //    *vertical-align: $ie-alignment;
		  //  }
		  //  *zoom: 1;
		  //  *display: inline;
		  //}
		}